/***************************************************************
 * Part     : FIFO CuE`t@C
 * Author   : 2019/01/14	nauzou
 */

#pragma	once

#include "std.h"

/********************************************************************
		eݒ
********************************************************************/
/*---------------------------------------------------------
  @obt@̐ݒ
---------------------------------------------------------*/
#define	FIFO_BUF_INITIALIZE		(0)		/* 1  fifo_init() sɃobt@ 0 	*/

/********************************************************************
		^錾
********************************************************************/
/*---------------------------------------------------------
  @FIFO obt@Ǘnh
---------------------------------------------------------*/
typedef	struct	{
		uint8			*buf_;			/* FIFO obt@ւ̃|C^				*/
		uint8			buf_size_;		/* obt@TCY							*/
		volatile uint8	add_idx_;		/* f[^ǉʒu							*/
		volatile uint8	out_idx_;		/* f[^oʒu						*/
		volatile uint8	data_num_;		/* FIFO obt@ɓĂf[^		*/
} FIFOBUF;

/********************************************************************
		CC֐
********************************************************************/
/*---------------------------------------------------------
 * Function :
 *  @w FIFO obt@̋󂫗eʂ𓾂B
 *
 * Arguments :
 *		hdl			: 󂫗eʂ𓾂 FIFO obt@̃nh
 *
 * Return :
 *  @FIFO obt@̋󂫗eʂԂB
 */
static inline uint8
fifo_free_num( FIFOBUF *hdl )
{
	return hdl->buf_size_ - hdl->data_num_;
}
/*---------------------------------------------------------
 * Function :
 *  @w FIFO obt@ɓĂf[^𓾂B
 *
 * Arguments :
 *		hdl			: f[^𓾂 FIFO obt@̃nh
 *
 * Return :
 *  @FIFO obt@ɓĂf[^ԂB
 */
static inline uint8
fifo_data_num( FIFOBUF *hdl )
{
	return hdl->data_num_;
}

/********************************************************************
		vg^Cv錾
********************************************************************/
/* fifo.c */
extern	void		fifo_init( FIFOBUF *hdl,uint8 *buf,uint8 buf_size );
extern	bool		fifo_add( FIFOBUF *hdl,uint8 data );
extern	bool		fifo_get( FIFOBUF *hdl,uint8 *buf );
